=== vendored-meson/meson/test cases/common/197 function attributes/meson_options.txt ===
option(
    'mode',
    type : 'combo',
    choices : ['single', 'parallel'],
    value : 'single',
    description : 'Test the one at a time function or many at a time function.'
)
