=== debian/changelog ===
numpy (1:2.2.4+ds-1ubuntu1) questing; urgency=medium

  * Rebuild for IEEE long double on ppc64el
  * Skip test_linear_interpolation_formula_symmetric and
    test_ppc64_ibm_double_double128 on ppc64el

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 01 Jun 2025 12:18:42 +0000

numpy (1:2.2.4+ds-1) unstable; urgency=medium

  * New upstream version 2.2.4+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 01 Apr 2025 21:45:23 +0200

numpy (1:2.2.3+ds-5) unstable; urgency=medium

  * Fix reproducibility issues with object files again

 -- Timo Röhling <roehling@debian.org>  Sun, 09 Mar 2025 21:14:24 +0100

numpy (1:2.2.3+ds-4) unstable; urgency=medium

  * Add --force option to dh_numpy3 and improve detection
  * Fix FTBFS on alpha and hurd-*

 -- Timo Röhling <roehling@debian.org>  Sat, 01 Mar 2025 22:25:17 +0100

numpy (1:2.2.3+ds-3) unstable; urgency=medium

  * Make dh_numpy3 smarter about adding ABI dependencies
  * Bump Standards-Version to 4.7.2

 -- Timo Röhling <roehling@debian.org>  Fri, 28 Feb 2025 14:47:44 +0100
