## numpy 2.3.2+ds

=== debian/changelog ===
numpy (1:2.3.2+ds-1) experimental; urgency=medium

  * New upstream version 2.3.2+ds
  * Update patches.
    Obsolete: 0007-Disable-plots-to-avoid-circular-NumPy-dependency.patch
  * Reintroduce python3-matplotlib dependency for documentation
  * Downgrade dh_numpy3 skip warning to a info message
  * Make random numbers in documentation reproducible
  * Skip numpy-config tests in test suite
  * Bump C API version to 20
  * Acknowledge NMUs for IEEE long double format change on ppc64el
  * Update cross-build helper to reflect said format change

 -- Timo Röhling <roehling@debian.org>  Mon, 08 Sep 2025 08:12:27 +0200

numpy (1:2.2.4+ds-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Skip two tests for IEEE long double on ppc64el (Graham Inggs).
    Closes: #1113967.

 -- Matthias Klose <doko@debian.org>  Fri, 05 Sep 2025 11:56:25 +0200

numpy (1:2.2.4+ds-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No-change upload for IEEE long double on ppc64el.

 -- Matthias Klose <doko@debian.org>  Thu, 04 Sep 2025 16:17:01 +0200
