## numpy 2.3.3%2Bds

=== vendored-meson/meson/test cases/failing/56 bad option argument/meson_options.txt ===
option('name', type : 'string', value_ : 'foo')
