=== numpy/_core/src/highway/CMakeLists.txt ===
--- 
+++ 
@@ -68,6 +68,14 @@
 # The following is only required with GCC < 6.1.0 or CLANG < 16.0
 set(HWY_CMAKE_ARM7 OFF CACHE BOOL "Set copts for Armv7 with NEON (requires vfpv4)?")
 
+# Upstream compilers(GCC 14 or CLANG 18) start enabling LSX by default, but
+# enabling LASX still require -mlasx flag to be passed explicitly, in order
+# to enable all targets, we can check them directly, adding them if they are
+# supported.  In this way, Our local compilers(GCC 8.3.0 or CLANG 8.0.1) also
+# could enable LSX & LASX targets.  Any better ideas or suggestions are welcome.
+set(HWY_CMAKE_LSX ON CACHE BOOL "Add -mlsx flag?")
+set(HWY_CMAKE_LASX ON CACHE BOOL "Add -mlasx flag?")
+
 # This must be set on 32-bit x86 with GCC < 13.1, otherwise math_test will be
 # skipped. For GCC 13.1+, you can also build with -fexcess-precision=standard.
 set(HWY_CMAKE_SSE2 OFF CACHE BOOL "Set SSE2 as baseline for 32-bit x86?")
@@ -135,6 +143,89 @@
     }"
   HWY_RISCV
 )
+
+if (CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch32|loongarch64")
+  include(CheckCXXCompilerFlag)
+  if (HWY_CMAKE_LSX)
+    set (CMAKE_REQUIRED_FLAGS -mlsx)
+    check_cxx_source_compiles(
+       "int main() {
+          #if !defined(__loongarch_sx)
+          static_assert(false, \"__loongarch_sx is not defined\");
+          #endif
+          return 0;
+        }"
+      COMPILER_SUPPORT_LSX_FLAG
+    )
+  endif()
+  if (HWY_CMAKE_LASX)
+    set (CMAKE_REQUIRED_FLAGS -mlasx)
+    check_cxx_source_compiles(
+       "int main() {
+          #if !defined(__loongarch_asx)
+          static_assert(false, \"__loongarch_asx is not defined\");
+          #endif
+          return 0;
+       }"
+      COMPILER_SUPPORT_LASX_FLAG
+    )
+  endif()
+endif()
+
+if (WIN32)
+  set (ORIG_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
+  set (CMAKE_REQUIRED_LIBRARIES synchronization)
+  check_cxx_source_compiles(
+    "#ifndef NOMINMAX
+     #define NOMINMAX
+     #endif
+
+     #include <windows.h>
+
+     int main() {
+       unsigned val1 = 0u;
+       unsigned val2 = 1u;
+       WaitOnAddress(&val1, &val2, sizeof(unsigned), 1);
+       WakeByAddressAll(&val1);
+       WakeByAddressSingle(&val1);
+       return 0;
+     }"
+  HWY_HAVE_WIN32_SYNCHRONIZATION_LIB)
+  set (CMAKE_REQUIRED_LIBRARIES ${ORIG_CMAKE_REQUIRED_LIBRARIES})
+else()
+  set (HWY_HAVE_WIN32_SYNCHRONIZATION_LIB OFF)
+endif ()
+
+if (HWY_HAVE_WIN32_SYNCHRONIZATION_LIB OR NOT WIN32)
+  set (HWY_DISABLE_FUTEX OFF CACHE BOOL "Disable futex for thread_pool")
+else()
+  # Force HWY_DISABLE_FUTEX to ON if compiling for Win32 and
+  # libsynchronization.a or synchronization.lib is not available
+  set (HWY_DISABLE_FUTEX ON CACHE BOOL "Disable futex for thread_pool" FORCE)
+endif()
+
+find_package(Threads)
+
+if (NOT Threads_FOUND AND HWY_ENABLE_CONTRIB)
+  message(FATAL_ERROR "Threads must be available if HWY_ENABLE_CONTRIB is ON")
+endif()
+
+if(Threads_FOUND)
+  if(THREADS_HAVE_PTHREAD_ARG)
+    set(HWY_THREAD_FLAGS "-pthread")
+  else()
+    set(HWY_THREAD_FLAGS "")
+  endif()
+
+  if(CMAKE_THREAD_LIBS_INIT)
+    set(HWY_THREAD_LIBS ${CMAKE_THREAD_LIBS_INIT})
+  else()
+    set(HWY_THREAD_LIBS "")
+  endif()
+else()
+  set(HWY_THREAD_FLAGS "")
+  set(HWY_THREAD_LIBS "")
+endif()
 
 if (HWY_RISCV OR CMAKE_CXX_COMPILER_ARCHITECTURE_ID MATCHES "RISCV32|RISCV64|RISCV128" OR CMAKE_SYSTEM_PROCESSOR MATCHES "riscv32|riscv64|riscv128")
   include(CheckCSourceCompiles)
@@ -184,6 +275,7 @@
     hwy/contrib/sort/vqsort.cc
     hwy/contrib/sort/vqsort.h
     hwy/contrib/thread_pool/futex.h
+    hwy/contrib/thread_pool/spin.h
     hwy/contrib/thread_pool/thread_pool.h
     hwy/contrib/thread_pool/topology.cc
     hwy/contrib/thread_pool/topology.h
@@ -197,6 +289,7 @@
 set(HWY_SOURCES
     hwy/abort.h
     hwy/aligned_allocator.h
+    hwy/auto_tune.h
     hwy/base.h
     hwy/cache_control.h
     hwy/detect_compiler_arch.h  # private
@@ -210,6 +303,8 @@
     hwy/ops/emu128-inl.h
     hwy/ops/generic_ops-inl.h
     hwy/ops/inside-inl.h
+    hwy/ops/loongarch_lsx-inl.h
+    hwy/ops/loongarch_lasx-inl.h
     hwy/ops/ppc_vsx-inl.h
     hwy/ops/rvv-inl.h
     hwy/ops/scalar-inl.h
@@ -228,6 +323,7 @@
     hwy/targets.h
     hwy/timer-inl.h
     hwy/timer.h
+    hwy/x86_cpuid.h
 )
 
 if (NOT HWY_CMAKE_HEADER_ONLY)
@@ -238,6 +334,7 @@
     hwy/per_target.cc
     hwy/perf_counters.cc
     hwy/print.cc
+    hwy/profiler.cc
     hwy/targets.cc
     hwy/timer.cc
   )
@@ -322,102 +419,3 @@
     -Wcast-align # see -Wcast-align=strict on x86
   )
 
-  if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-    list(APPEND HWY_FLAGS
-      -Wfloat-overflow-conversion
-      -Wfloat-zero-conversion
-      -Wfor-loop-analysis
-      -Wgnu-redeclared-enum
-      -Winfinite-recursion
-      -Wself-assign
-      -Wstring-conversion
-      -Wtautological-overlap-compare
-      -Wthread-safety-analysis
-      -Wundefined-func-template
-
-      -fno-cxx-exceptions
-      -fno-slp-vectorize
-      -fno-vectorize
-
-      # Use color in messages
-      -fdiagnostics-show-option -fcolor-diagnostics
-    )
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 6.0)
-      list(APPEND HWY_FLAGS -Wc++2a-extensions)
-    endif()
-  endif()
-
-  if (WIN32)
-    if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-      list(APPEND HWY_FLAGS
-        -Wno-global-constructors
-        -Wno-language-extension-token
-        -Wno-used-but-marked-unused
-        -Wno-shadow-field-in-constructor
-        -Wno-unused-member-function
-        -Wno-unused-template
-        -Wno-c++98-compat-pedantic
-        -Wno-used-but-marked-unused
-        -Wno-zero-as-null-pointer-constant
-      )
-    endif()
-
-    list(APPEND HWY_FLAGS
-      -Wno-cast-align
-      -Wno-double-promotion
-      -Wno-float-equal
-      -Wno-format-nonliteral
-      -Wno-shadow
-      -Wno-sign-conversion
-    )
-  else()
-    list(APPEND HWY_FLAGS
-      -fmath-errno
-      -fno-exceptions
-    )
-  endif()  # WIN32
-
-  # Workaround for excess precision, see #1488.
-  if (HWY_CMAKE_SSE2)
-    list(APPEND HWY_FLAGS -msse2 -mfpmath=sse)
-  endif()
-
-  # Suppress STL iterator warnings. Supported by GCC 4.4.7 and newer, which
-  # predates the C++11 we require.
-  if (${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
-    list(APPEND HWY_FLAGS -Wno-psabi)
-  endif()
-  # Clang supports this flag from 11.0.
-  if (${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
-    if (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER_EQUAL 11.0)
-      list(APPEND HWY_FLAGS -Wno-psabi)
-    endif()
-  endif()
-
-  if (HWY_CMAKE_ARM7)
-    list(APPEND HWY_FLAGS
-      -march=armv7-a
-      -mfpu=neon-vfpv4
-      -mfloat-abi=hard  # must match the toolchain specified as CXX=
-    )
-    if(${CMAKE_CXX_COMPILER_ID} MATCHES "GNU")
-      # using GCC
-      list(APPEND HWY_FLAGS
-        -mfp16-format=ieee  # required for vcvt_f32_f16
-      )
-    endif()
-  endif()  # HWY_CMAKE_ARM7
-
-  if(HWY_RISCV)
-    # gcc(13) and recent clang both support V, but not yet runtime dispatch, so
-    # we add the gcv compiler flag, which then requires the CPU (now when using
-    # either compiler) to support V.
-    if(HWY_CMAKE_RVV)
-      if(RISCV_XLEN EQUAL 64)
-        list(APPEND HWY_FLAGS -march=rv64gcv1p0)
-        add_link_options(-march=rv64gcv1p0)
-      elseif(RISCV_XLEN EQUAL 32)
-        list(APPEND HWY_FLAGS -march=rv32gcv1p0)
-        add_link_options(-march=rv32gcv1p0)
-      endif()
-      if(${CMAKE_CXX_COMPILER_ID} MATCHES "Clang")
