=== vendored-meson/meson/test cases/common/192 feature option/meson_options.txt ===
option('required', type : 'feature', value : 'enabled', description : 'An required feature')
option('optional', type : 'feature', value : 'auto', description : 'An optional feature')
option('disabled', type : 'feature', value : 'disabled', description : 'A disabled feature')
