=== vendored-meson/meson/test cases/failing/14 invalid option name/meson_options.txt ===
option('invalid:name', type : 'boolean', value : false)
