=== vendored-meson/meson/test cases/unit/125 declare_dep var/meson_options.txt ===
option('dir', type: 'string')
