=== vendored-meson/meson/test cases/unit/39 external, internal library rpath/built library/meson_options.txt ===
option('foo_system_path', type: 'string', value: '')
