=== vendored-meson/meson/test cases/rust/22 cargo subproject/subprojects/extra-dep-1-rs/meson_options.txt ===
option('feature-default', type: 'boolean', value: true)
