=== debian/changelog ===
numpy (1:2.3.3+ds-3ubuntu1) resolute; urgency=medium

  * Skip test_cpu_features on ppc64el and s390x (LP: #2127939)

 -- Graham Inggs <ginggs@ubuntu.com>  Sat, 18 Oct 2025 14:38:40 +0000

numpy (1:2.3.3+ds-3) unstable; urgency=medium

  * Reproducible Builds fix
  * Monkeypatch numpy.random.default_rng for reproducible documentation
  * Do not run %timeit during documentation build

 -- Timo Röhling <roehling@debian.org>  Fri, 10 Oct 2025 12:42:48 +0200

numpy (1:2.3.3+ds-2) unstable; urgency=medium

  * Upload to unstable.
  * Skip test that fails on armel

 -- Timo Röhling <roehling@debian.org>  Thu, 09 Oct 2025 10:05:50 +0200

numpy (1:2.3.3+ds-1) experimental; urgency=medium

  * New upstream version 2.3.3+ds
  * Refresh patches (no functional changes)

 -- Timo Röhling <roehling@debian.org>  Tue, 16 Sep 2025 12:49:37 +0200
