=== debian/control ===
--- 
+++ 
@@ -40,6 +40,7 @@
  python3-breathe <!nodoc>,
  python3-doc <!nodoc>,
  python3-ipython <!nodoc>,
+ python3-matplotlib <!nodoc>,
  python3-numpydoc <!nodoc>,
  python3-pickleshare <!nodoc>,
  python3-pydata-sphinx-theme <!nodoc>,
