## numpy 2.3.4%2Bds

=== debian/changelog ===
numpy (1:2.3.4+ds-3) unstable; urgency=medium

  * Fix compatibility with SWIG >= 4.4.
    Thanks to Rafael Laboissière (Closes: #1119878)

 -- Timo Röhling <roehling@debian.org>  Mon, 03 Nov 2025 16:00:11 +0100

numpy (1:2.3.4+ds-2) unstable; urgency=medium

  * Skip failing tests on riscv64

 -- Timo Röhling <roehling@debian.org>  Tue, 28 Oct 2025 22:50:45 +0100

numpy (1:2.3.4+ds-1) unstable; urgency=medium

  * New upstream version 2.3.4+ds
  * Disable version warning banner in offline documentation
  * Migrate debian/watch to version 5 format
  * Refresh patches (no functional changes)
  * Fix f2py object file handling regression with meson backend
    (Closes: #1078861)
  * Build-Depend on python3-pytz instead of deprecated python3-tz

 -- Timo Röhling <roehling@debian.org>  Tue, 28 Oct 2025 10:40:01 +0100
